Part Module: Difference between revisions

From FreeCAD Documentation
(Marked this version for translation)
m (added descriptive summary for 'Part_SectionCross')
(88 intermediate revisions by 5 users not shown)
Line 1: Line 1:
<languages/>
<languages/>
[[Image:Workbench_Part.svg|64px]]
<translate>
<translate>
<!--T:52-->
{{Docnav
|[[OpenSCAD Module|OpenSCAD Module]]
|[[PartDesign Workbench|PartDesign Workbench]]
|IconL=Workbench_OpenSCAD.svg
|IconR=Workbench_PartDesign.svg
}}

</translate>
[[Image:Workbench_Part.svg|240px|center]]
<translate>
<!--T:66-->
{{Caption|align=center|The FreeCAD Part Workbench Icon}}


== Introduction == <!--T:1-->
== Introduction == <!--T:1-->
The solid modelling capabilities of FreeCAD are based on the [http://en.wikipedia.org/wiki/Open_Cascade_Technology Open Cascade Technology] (OCCT) kernel, a professional-grade CAD system that features advanced 3D geometry creation and manipulation.
The solid modelling capabilities of FreeCAD are based on the [http://en.wikipedia.org/wiki/Open_Cascade_Technology Open Cascade Technology] (OCCT) kernel, a professional-grade CAD system that features advanced 3D geometry creation and manipulation. The [[Image:Workbench_Part.svg|24px]] [[Part Workbench|Part Workbench]] is a layer sitting on top of the OCCT libraries, that gives the user access to OCCT geometric primitives and functions. Essentially all 2D and 3D drawing functions in every workbench ([[Image:Workbench_Draft.svg|24px]] [[Draft Workbench|Draft]], [[Image:Workbench_Sketcher.svg|24px]] [[Sketcher Workbench|Sketcher]], [[Image:Workbench_PartDesign.svg|24px]] [[PartDesign Workbench|PartDesign]], etc.), are based on these functions exposed by the Part Workbench. Therefore, the Part Workbench is considered the core component of the modelling capabilities of FreeCAD.


<!--T:35-->
<!--T:35-->
The objects created with the Part Workbench are relatively simple; they are intended to be used with boolean operations (unions and cuts) in order to build more complex shapes. '''This modeling paradigm is known as the [[constructive solid geometry]] (CSG) workflow, and it was the traditional methodology used in early CAD systems.''' On the other hand, the [[PartDesign Workbench|PartDesign Workbench]] provides a more modern workflow to constructing shapes: it uses a parametrically defined sketch, that is extruded to form a basic solid body, which is then modified by parametric transformations ([[feature editing|feature editing]]), until the final object is obtained.
The [[Part Workbench]] allows the user to access and use the OCCT objects and functions. Part objects, unlike [[Mesh Workbench|Mesh objects]], are more complex, and therefore permit more advanced operations like coherent boolean operations, modifications history, and parametric behaviour.

<!--T:54-->
Part objects are more complex than mesh objects created with the [[Mesh Workbench|Mesh Workbench]], as they permit more advanced operations like coherent boolean operations, modifications history, and parametric behaviour.


</translate>
</translate>
{{TOCright}}
{{TOCright}}
[[Image:Part example.jpg]]
[[Image:Part example.jpg]]

[[Image:Part_Workbench_relationships.svg|600px]]
<translate>
<translate>

<!--T:55-->
{{Caption|The Part Workbench is the basic layer that exposes the OCCT drawing functions to all workbenches in FreeCAD}}


== Tools == <!--T:4-->
== Tools == <!--T:4-->
Line 25: Line 45:


<!--T:37-->
<!--T:37-->
* [[Image:Part_Box.png|32px]] [[Part_Box|Box]]: Draws a box by specifying its dimensions
* [[Image:Part_Box.svg|32px]] [[Part_Box|Box]]: Draws a box by specifying its dimensions
* [[Image:Part_Cone.png|32px]] [[Part_Cone|Cone]]: Draws a cone by specifying its dimensions
* [[Image:Part_Cylinder.svg|32px]] [[Part_Cylinder|Cylinder]]: Draws a cylinder by specifying its dimensions
* [[Image:Part_Cylinder.png|32px]] [[Part_Cylinder|Cylinder]]: Draws a cylinder by specifying its dimensions
* [[Image:Part_Sphere.svg|32px]] [[Part_Sphere|Sphere]]: Draws a sphere by specifying its dimensions
* [[Image:Part_Sphere.png|32px]] [[Part_Sphere|Sphere]]: Draws a sphere by specifying its dimensions
* [[Image:Part_Cone.svg|32px]] [[Part_Cone|Cone]]: Draws a cone by specifying its dimensions
* [[Image:Part_Torus.png|32px]] [[Part_Torus|Torus]]: Draws a torus (ring) by specifying its dimensions
* [[Image:Part_Torus.svg|32px]] [[Part_Torus|Torus]]: Draws a torus (ring) by specifying its dimensions
* [[Image:Part_CreatePrimitives.png|32px]] [[Part_CreatePrimitives|CreatePrimitives]]: A tool to create various parametric geometric primitives
* [[Image:Part_CreatePrimitives.svg|32px]] [[Part_CreatePrimitives|CreatePrimitives]]: A tool to create various parametric geometric primitives
* [[Image:Part_Shapebuilder.png|32px]] [[Part_Shapebuilder|Shapebuilder]]: A tool to create more complex shapes from various parametric geometric primitives
* [[Image:Part_Shapebuilder.svg|32px]] [[Part_Shapebuilder|Shapebuilder]]: A tool to create more complex shapes from various parametric geometric primitives


===Modifying objects=== <!--T:38-->
===Modifying objects=== <!--T:38-->
Line 39: Line 59:


<!--T:40-->
<!--T:40-->
* [[Image:Part_Booleans.png|32px]] [[Part_Booleans|Booleans]]: Performs boolean operations on objects
* [[Image:Part_Extrude.svg|32px]] [[Part_Extrude|Extrude]]: Extrudes planar faces of an object
* [[Image:Part_Union.png|32px]] [[Part_Union|Union]]: Fuses (unions) two objects
* [[Image:Part_Revolve.svg|32px]] [[Part_Revolve|Revolve]]: Creates a solid by revolving another object (not solid) around an axis
* [[Image:Part_Common.png|32px]] [[Part_Common|Common]]: Extracts the common (intersection) part of two objects
* [[Image:Part_Mirror.svg|32px]] [[Part_Mirror|Mirror]]: Mirrors the selected object on a given mirror plane
* [[Image:Part_Cut.png|32px]] [[Part_Cut|Cut]]: Cuts (subtracts) one object from another
* [[Image:Part_Fillet.svg|32px]] [[Part_Fillet|Fillet]]: Fillets (rounds) edges of an object
* [[Image:Part JoinConnect.png|32px]] [[Part CompJoinFeatures|Join features]]: smart booleans for walled objects (e.g., pipes) (v0.16)
* [[Image:Part_Chamfer.svg|32px]] [[Part_Chamfer|Chamfer]]: Chamfers edges of an object
** [[Image:Part JoinConnect.png|32px]] [[Part_JoinConnect|Connect]]: Connects interiors of objects (v0.16)
* [[Image:Part_RuledSurface.svg|32px]] [[Part_RuledSurface|Ruled Surface]]:
** [[Image:Part JoinEmbed.png|32px]] [[Part_JoinEmbed|Embed]]: Embeds a walled object into another walled object (v0.16)
* [[Image:Part_Loft.svg|32px]] [[Part_Loft|Loft]]: Lofts from one profile to another
** [[Image:Part JoinCutout.png|32px]] [[Part_JoinCutout|Cutout]]: Creates a cutout in a wall of an object for another walled object (v0.16)
* [[Image:Part_Sweep.svg|32px]] [[Part_Sweep|Sweep]]: Sweeps one or more profiles along a path

* Splitting tools: (v0.17)
<!--T:45-->
** [[Image:Part BooleanFragments.png|32px]] [[Part_BooleanFragments|Boolean fragments]]: makes all the pieces that can be obtained by Boolean operations between objects (v0.17)
* [[Image:Part_CompOffsetTools.png|48px]] [[Part_CompOffsetTools|Offset tools]]:
** [[Image:Part Slice.png|32px]] [[Part_Slice|Slice]]: Splits an object into pieces by intersections with another object (v0.17)
** [[Image:Part XOR.png|32px]] [[Part_XOR|XOR]]: removes space shared by even number of objects (symmetric version of [[Part_Cut|Cut]]) (v0.17)
** [[Image:Part_Offset.svg|32px]] [[Part_Offset|3D Offset]]: Constructs a parallel shape at a certain distance from original.
** [[Image:Part_Offset2D.svg|32px]] [[Part_Offset2D|2D Offset]]: Constructs a parallel wire at certain distance from original, or enlarges/shrinks a planar face. {{Version|0.17}}
* Compound

** [[Image:Part MakeCompound.png|32px]] [[Part MakeCompound|Make compound]]: Creates a compound from the selected objects.
<!--T:46-->
** [[Image:Part Compound‏‎Filter.png|32px]] [[Part Compound‏‎Filter|Compound Filter]]: The CompoundFilter can be used to extract the individual pieces.
* [[Image:Part_Extrude.png|32px]] [[Part_Extrude|Extrude]]: Extrudes planar faces of an object
* [[Image:Part_Thickness.svg|32px]] [[Part_Thickness|Thickness]]: Hollows out a solid, leaving openings next to select faces.

* [[Image:Part_Fillet.png|32px]] [[Part_Fillet|Fillet]]: Fillets (rounds) edges of an object
<!--T:57-->
* [[Image:Part_Revolve.png|32px]] [[Part_Revolve|Revolve]]: Creates a solid by revolving another object (not solid) around an axis
* [[Image:Part_ProjectionOnSurface.png|32px]] [[Part_ProjectionOnSurface|Projection on surface]]: Project a logo, text or any face,wire,edge to a surface. With the projection part it is possible to create a solid or wire. {{Version|0.19}}
* [[Image:Part_Section.png|32px]] [[Part_Section|Section]]: Creates a section by intersecting an object with a section plane

* [[Image:Part_SectionCross.png|32px]] [[Part_SectionCross|Cross sections...]]:
<!--T:47-->
* [[Image:Part_Chamfer.png|32px]] [[Part_Chamfer|Chamfer]]: Chamfers edges of an object
* [[Image:Part_Compound.svg|48px]] [[Part_CompCompoundTools|Compound Tools]]:
* [[Image:Part_Mirror.png|32px]] [[Part_Mirror|Mirror]]: Mirrors the selected object on a given mirror plane
* [[Image:Part_RuledSurface.png|32px]] [[Part_RuledSurface|Ruled Surface]]:
** [[Image:Part_Compound.svg|32px]] [[Part_Compound|Make compound]]: Creates a compound from the selected objects.
* [[Image:Part_Sweep.png|32px]] [[Part_Sweep|Sweep]]: Sweeps one or more profiles along a path
** [[Image:Part_ExplodeCompound.svg|32px]] [[Part_ExplodeCompound|Explode Compound]]: Tool to split up compounds of shapes
* [[Image:Part_Loft.png|32px]] [[Part_Loft|Loft]]: Lofts from one profile to another
** [[Image:Part Compound‏‎Filter.svg|32px]] [[Part Compound‏‎Filter|Compound Filter]]: The CompoundFilter can be used to extract the individual pieces.

* Offset tools:
<!--T:48-->
** [[Image:Part_Offset.png|32px]] [[Part_Offset|3D Offset]]: Constructs a parallel shape at a certain distance from original.
* [[Image:Part_Booleans.svg|32px]] [[Part_Booleans|Booleans]]: Performs boolean operations on objects
** [[Image:Part_Offset2D.png|32px]] [[Part_Offset2D|2D Offset]]: Constructs a parallel wire at certain distance from original, or enlarges/shrinks a planar face. (v0.17)
** [[Image:Part_Thickness.png|32px]] [[Part_Thickness|Thickness]]: Hollows out a solid, leaving openings next to select faces.
* [[Image:Part_Fuse.svg|32px]] [[Part_Union|Union]]: Fuses (unions) two objects
* [[Image:Part_Common.svg|32px]] [[Part_Common|Common]]: Extracts the common (intersection) part of two objects
* [[Image:Part_Cut.svg|32px]] [[Part_Cut|Cut]]: Cuts (subtracts) one object from another

<!--T:49-->
* [[Image:Part_CompJoinFeatures.png|48px]] [[Part CompJoinFeatures|Join features]]: smart booleans for walled objects (e.g., pipes) {{Version|0.16}}
** [[Image:Part_JoinConnect.svg|32px]] [[Part_JoinConnect|Connect]]: Connects interiors of objects {{Version|0.16}}
** [[Image:Part_JoinEmbed.svg|32px]] [[Part_JoinEmbed|Embed]]: Embeds a walled object into another walled object {{Version|0.16}}
** [[Image:Part_JoinCutout.svg|32px]] [[Part_JoinCutout|Cutout]]: Creates a cutout in a wall of an object for another walled object {{Version|0.16}}

<!--T:50-->
* [[Image:Part_CompSplittingTools.png|48px]] [[Part CompSplittingTools|Splitting tools]]: {{Version|0.17}}
** [[Image:Part_BooleanFragments.svg|32px]] [[Part_BooleanFragments|Boolean fragments]]: makes all the pieces that can be obtained by Boolean operations between objects {{Version|0.17}}
** [[Image:Part SliceApart.svg|32px]] [[Part_SliceApart|Slice a part]]: tool to split shapes by intersection with other shapes
** [[Image:Part_Slice.svg|32px]] [[Part_Slice|Slice]]: Splits an object into pieces by intersections with another object {{Version|0.17}}
** [[Image:Part_XOR.svg|32px]] [[Part_XOR|XOR]]: removes space shared by even number of objects (symmetric version of [[Part_Cut|Cut]]) {{Version|0.17}}

<!--T:51-->
* [[Image:Part Defeaturing.svg|32px]] [[Part_Defeaturing|Defeaturing]]: {{Version|0.18}}
* [[Image:Part_Section.svg|32px]] [[Part_Section|Section]]: Creates a section by intersecting an object with a section plane
* [[Image:Part_CrossSections.svg|32px]] [[Part_SectionCross|Cross sections...]]: Creates one or more cross-sections through a selected shape
* [[Image:Part Attachment.svg|32px]] [[Part Attachment|Attachment]]: attachment is a utility to attach an object to another one.

=== Measure === <!--T:58-->

<!--T:59-->
[[File:Std Measure Menu.png|64px]] [[Std Measure Menu|Measure]]: Allows linear and angular measurement between points, edges, and faces.

<!--T:60-->
* [[Image:Part_Measure_Linear.svg|32px]] [[Part_Measure_Linear|Measure Linear]] allows you to make linear measurements.
* [[Image:Part_Measure_Angular.svg|32px]] [[Part_Measure_Angular|Measure Angular]] allows you to make angular measurements.
* [[Image:Part_Measure_Refresh.svg|32px]] [[Part_Measure_Refresh|Measure Refresh]] updates the measurements on screen.
* [[Image:Part_Measure_Clear_All.svg|32px]] [[Part_Measure_Clear_All|Clear All]] Clears all measurements.
* [[Image:Part_Measure_Toggle_All.svg|32px]] [[Part_Measure_Toggle_All|Toggle All]] shows or hides all measurements.
* [[Image:Part_Measure_Toggle_3d.svg|32px]] [[Part_Measure_Toggle_3d|Toggle 3D]] shows or hides 3D measurements.
* [[Image:Part_Measure_Toggle_Delta.svg|32px]] [[Part_Measure_Toggle_Delta|Toggle Delta]] shows or hides delta measurements.


===Other tools=== <!--T:41-->
===Other tools=== <!--T:41-->


<!--T:42-->
<!--T:42-->
* [[Image:Part ImportCAD.png|32px]] [[Part ImportCAD|Import CAD]]: This tool allows you to add a file *.IGES, *.STEP, *.BREP to the current document.
* [[Image:Part_Import.svg|32px]] [[Part Import|Import]]: This tool allows you to add a file *.IGES, *.STEP, *.BREP to the current document.
* [[Image:Part ExportCAD.png|32px]] [[Part ExportCAD|Export CAD]]: This tool allows you to export a part object in a *.IGES, *.STEP, *.BREP file.
* [[Image:Part_Export.svg|32px]] [[Part Export|Export]]: This tool allows you to export a part object in a *.IGES, *.STEP, *.BREP file.
* [[File:Part_BoxSelection.svg|32px]] [[Part_BoxSelection|BoxSelection]]: add to the selection the faces of the shapes that are touches by the rectangular selection. {{Version|0.19}}
* [[Image:Part ShapeFromMesh.png|32px]] [[Part ShapeFromMesh|Shape from Mesh]]: Creates a shape object from a mesh object.
* [[Part ConvertToSolid|Convert to solid]]: Converts a shape object to a solid object.
* [[Image:Part_ShapeFromMesh.svg|32px]] [[Part ShapeFromMesh|Shape from Mesh]]: Creates a shape object from a mesh object.
* [[File:Part_PointsFromMesh.svg|32px]] [[Part PointsFromMesh|Points from mesh]]: creates a shape object made of points from the mesh. {{Version|0.19}}
* [[Part ReverseShapes|Reverse shapes]]: Flips the normals of all faces of the selected object.
* [[Part CreateSimpleCopy|Create simple copy]]: Creates a simple copy of the selected object.
* [[Part_ConvertToSolid|Convert to solid]]: Converts a shape object to a solid object.
* [[Part_ReverseShapes|Reverse shapes]]: Flips the normals of all faces of the selected object.
* [[Image:Part RefineShape.png|32px]] [[Part RefineShape|Refine shape]]: Cleans faces by removing unnecessary lines.
* [[Image:Part CheckGeometry.png|32px]] [[Part CheckGeometry|Check geometry]]: Checks the geometry of selected objects for errors.
* [[Std Measure Menu|Measure]]: Allows linear and angular measurement between points/edges/faces.


<!--T:61-->
</translate>
* Create a copy:
[[Image:Part_Boolean_example.png|600px|none]]
** [[Image:Part_SimpleCopy‎.svg|32px]] [[Part_SimpleCopy|Create simple copy]]: Creates a simple copy of the selected object.
<translate>
** [[File:Part_TransformedCopy.svg|32px]] [[Part_TransformedCopy|Create transformed copy]]: creates a transformed copy of the selected object. {{Version|0.19}}
<!--T:8-->
** [[File:Part_ElementCopy.svg|32px]] [[Part_ElementCopy|Create shape element copy]]: creates a copy from an element (vertex, edge, face) of the selected object. {{Version|0.19}}
{{Caption|An example of fusion (union), intersection (common) and difference (cut) of solid shapes}}
** [[Image:Part_RefineShape.svg|32px]] [[Part_RefineShape|Refine shape]]: Cleans faces by removing unnecessary lines.

<!--T:62-->
* [[Image:Part_CheckGeometry.svg|32px]] [[Part CheckGeometry|Check geometry]]: Checks the geometry of selected objects for errors.


== Preferences == <!--T:43-->
== Preferences == <!--T:43-->
Line 99: Line 156:


<!--T:13-->
<!--T:13-->
In summary, geometry primitives are "shapeless" building blocks, while topological shapes are the real objects built on them.
In summary, geometry primitives are "shapeless" building blocks, while [[Part_TopoShape|topological shapes]] are the real objects built on them.


<!--T:14-->
<!--T:14-->
Line 112: Line 169:
<!--T:17-->
<!--T:17-->
Thus, out of shapes you can build very complex parts or, the other way round, extract all sub-shapes a more complex shape is made of.
Thus, out of shapes you can build very complex parts or, the other way round, extract all sub-shapes a more complex shape is made of.

</translate>
[[File:Part_TopoShape_relationships.svg|600px]]
<translate>

<!--T:65-->
{{Caption|The {{incode|Part::TopoShape}} class is the geometrical object that is seen on screen. Essentially all workbenches use these [[Part_TopoShape|TopoShapes]] internally to build and display edges, faces, and solids.}}


== Scripting == <!--T:18-->
== Scripting == <!--T:18-->

<!--T:56-->
{{Emphasis|See also:}} [[Part scripting|Part scripting]]


<!--T:19-->
<!--T:19-->
The main data structure used in the Part module is the [http://en.wikipedia.org/wiki/Boundary_representation BRep] data type from OpenCascade.
The main data structure used in the Part module is the [http://en.wikipedia.org/wiki/Boundary_representation BRep] data type from OpenCascade.
Almost all contents and object types of the Part module are available by [[Python]] scripting. This includes geometric primitives, such as Line and Circle (or Arc), and the whole range of TopoShapes, like Vertexes, Edges, Wires, Faces, Solids and Compounds. For each of those objects, several creation methods exist, and for some of them, especially the TopoShapes, advanced operations like boolean union/difference/intersection are also available. Explore the contents of the Part module, as described in the [[FreeCAD Scripting Basics]] page, to know more.
Almost all contents and object types of the Part module are available by [[Python|Python]] scripting. This includes geometric primitives, such as Line and Circle (or Arc), and the whole range of TopoShapes, like Vertexes, Edges, Wires, Faces, Solids and Compounds. For each of those objects, several creation methods exist, and for some of them, especially the TopoShapes, advanced operations like boolean union/difference/intersection are also available. Explore the contents of the Part module, as described in the [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]] page, to know more.

<!--T:63-->
The most basic object that can be created is a [[Part Feature|Part Feature]], which has a simple {{PropertyData|Placement}} property, and basic properties to define its color and appearance.

<!--T:64-->
Another simple object used in 2D geometrical objects is [[Part Part2DObject|Part Part2DObject]], which is the base of [[Sketcher_SketchObject|Sketcher SketchObject]] ([[Sketcher Workbench|Sketcher]]), and most [[Draft Workbench|Draft elements]].

=== Test script === <!--T:69-->

<!--T:70-->
Test the creation of [[Part_Primitives|Part Primitives]] with a script. {{Version|0.19}}

</translate>
{{Code|code=
import parttests.part_test_objects as pto
pto.create_test_file("example_file")
}}
<translate>

<!--T:71-->
This script is located in the installation directory of the program, and can be examined to see how the basic primitives are built.
</translate>
{{Code|code=
$INSTALL_DIR/Mod/Part/parttests/part_test_objects.py
}}
<translate>


=== Examples === <!--T:20-->
=== Examples === <!--T:20-->
Line 123: Line 216:
<!--T:21-->
<!--T:21-->
To create a line element switch to the Python console and type in:
To create a line element switch to the Python console and type in:

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 134: Line 228:
}}
}}
<translate>
<translate>

<!--T:22-->
<!--T:22-->
Let's go through the above python example step by step:
Let's go through the above python example step by step:

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 142: Line 238:
}}
}}
<translate>
<translate>

<!--T:23-->
<!--T:23-->
loads the Part module and creates a new document
loads the Part module and creates a new document

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 151: Line 249:
}}
}}
<translate>
<translate>

<!--T:24-->
<!--T:24-->
Line is actually a line segment, hence the start and endpoint.
Line is actually a line segment, hence the start and endpoint.

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 158: Line 258:
}}
}}
<translate>
<translate>

<!--T:25-->
<!--T:25-->
This adds a Part object type to the document and assigns the shape representation of the line segment to the 'Shape' property of the added object. It is important to understand here that we used a geometric primitive (the Part.LineSegment) to create a TopoShape out of it (the toShape() method). Only Shapes can be added to the document. In FreeCAD, geometry primitives are used as "building structures" for Shapes.
This adds a Part object type to the document and assigns the shape representation of the line segment to the 'Shape' property of the added object. It is important to understand here that we used a geometric primitive (the Part.LineSegment) to create a TopoShape out of it (the toShape() method). Only Shapes can be added to the document. In FreeCAD, geometry primitives are used as "building structures" for Shapes.

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 165: Line 267:
}}
}}
<translate>
<translate>

<!--T:26-->
<!--T:26-->
Updates the document. This also prepares the visual representation of the new part object.
Updates the document. This also prepares the visual representation of the new part object.
Line 173: Line 276:
<!--T:28-->
<!--T:28-->
A circle can be created in a similar way:
A circle can be created in a similar way:

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 184: Line 288:
}}
}}
<translate>
<translate>

<!--T:29-->
<!--T:29-->
Note again, we used the circle (geometry primitive) to construct a shape out of it. We can of course still access our construction geometry afterwards, by doing:
Note again, we used the circle (geometry primitive) to construct a shape out of it. We can of course still access our construction geometry afterwards, by doing:

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 193: Line 299:
}}
}}
<translate>
<translate>

<!--T:30-->
<!--T:30-->
Here we take the shape of our object f, then we take its list of edges. In this case there will be only one because we made the whole shape out of a single circle, so we take only the first item of the Edges list, and we takes its curve. Every Edge has a Curve, which is the geometry primitive it is based on.
Here we take the shape of our object f, then we take its list of edges. In this case there will be only one because we made the whole shape out of a single circle, so we take only the first item of the Edges list, and we takes its curve. Every Edge has a Curve, which is the geometry primitive it is based on.


<!--T:31-->
<!--T:31-->
Head to the [[Topological data scripting]] page if you would like to know more.
Head to the [[Topological data scripting|Topological data scripting]] page if you would like to know more.


== Tutorials == <!--T:34-->
== Tutorials == <!--T:34-->
Line 205: Line 312:


<!--T:32-->
<!--T:32-->
{{Docnav
{{docnav|OpenSCAD Module|Drawing Module}}
|[[OpenSCAD Module|OpenSCAD Module]]
{{Userdocnavi}}
|[[PartDesign Workbench|PartDesign Workbench]]
[[Category:Part]]
|IconL=Workbench_OpenSCAD.svg
[[Category:Workbenches]]
|IconR=Workbench_PartDesign.svg
}}


</translate>
</translate>

{{Userdocnavi{{#translation:}}}}

{{Part Tools navi{{#translation:}}}}

[[Category:Workbenches{{#translation:}}]]

Revision as of 03:50, 26 February 2020

The FreeCAD Part Workbench Icon

Introduction

The solid modelling capabilities of FreeCAD are based on the Open Cascade Technology (OCCT) kernel, a professional-grade CAD system that features advanced 3D geometry creation and manipulation. The Part Workbench is a layer sitting on top of the OCCT libraries, that gives the user access to OCCT geometric primitives and functions. Essentially all 2D and 3D drawing functions in every workbench ( Draft, Sketcher, PartDesign, etc.), are based on these functions exposed by the Part Workbench. Therefore, the Part Workbench is considered the core component of the modelling capabilities of FreeCAD.

The objects created with the Part Workbench are relatively simple; they are intended to be used with boolean operations (unions and cuts) in order to build more complex shapes. This modeling paradigm is known as the constructive solid geometry (CSG) workflow, and it was the traditional methodology used in early CAD systems. On the other hand, the PartDesign Workbench provides a more modern workflow to constructing shapes: it uses a parametrically defined sketch, that is extruded to form a basic solid body, which is then modified by parametric transformations (feature editing), until the final object is obtained.

Part objects are more complex than mesh objects created with the Mesh Workbench, as they permit more advanced operations like coherent boolean operations, modifications history, and parametric behaviour.

The Part Workbench is the basic layer that exposes the OCCT drawing functions to all workbenches in FreeCAD

Tools

The tools are all located in the Part menu.

Primitives

These are tools for creating primitive objects.

  • Box: Draws a box by specifying its dimensions
  • Cylinder: Draws a cylinder by specifying its dimensions
  • Sphere: Draws a sphere by specifying its dimensions
  • Cone: Draws a cone by specifying its dimensions
  • Torus: Draws a torus (ring) by specifying its dimensions
  • File:Part CreatePrimitives.svg CreatePrimitives: A tool to create various parametric geometric primitives
  • Shapebuilder: A tool to create more complex shapes from various parametric geometric primitives

Modifying objects

These are tools for modifying existing objects. They will allow you to choose which object to modify.

  • Extrude: Extrudes planar faces of an object
  • Revolve: Creates a solid by revolving another object (not solid) around an axis
  • Mirror: Mirrors the selected object on a given mirror plane
  • Fillet: Fillets (rounds) edges of an object
  • Chamfer: Chamfers edges of an object
  • Ruled Surface:
  • Loft: Lofts from one profile to another
  • Sweep: Sweeps one or more profiles along a path
  • Thickness: Hollows out a solid, leaving openings next to select faces.
  • Booleans: Performs boolean operations on objects
  • Union: Fuses (unions) two objects
  • Common: Extracts the common (intersection) part of two objects
  • Cut: Cuts (subtracts) one object from another

Measure

File:Std Measure Menu.png Measure: Allows linear and angular measurement between points, edges, and faces.

Other tools

Preferences

OCCT geometric concepts

In OpenCascade terminology, we distinguish between geometric primitives and topological shapes. A geometric primitive can be a point, a line, a circle, a plane, etc. or even some more complex types like a B-Spline curve or a surface. A shape can be a vertex, an edge, a wire, a face, a solid or a compound of other shapes. The geometric primitives are not made to be directly displayed on the 3D scene, but rather to be used as building geometry for shapes. For example, an edge can be constructed from a line or from a portion of a circle.

In summary, geometry primitives are "shapeless" building blocks, while topological shapes are the real objects built on them.

A complete list of all primitives and shapes refer to the OCC documentation (Alternative: sourcearchive.com) and search for Geom_* (for geometric primitives) and TopoDS_* (for shapes). There you can also read more about the differences between them. Please note that the official OCC documentation is not available online (you must download an archive) and is mostly aimed at programmers, not at end-users. But hopefully you'll find enough information to get started here.

The geometric types actually can be divided into two major groups: curves and surfaces. Out of the curves (line, circle, ...) you can directly build an edge, out of the surfaces (plane, cylinder, ...) a face can be built. For example, the geometric primitive line is unlimited, i.e. it is defined by a base vector and a direction vector while its shape representation must be something limited by a start and end point. And a box -- a solid -- can be created by six limited planes.

From an edge or face you can also go back to its geometric primitive counterpart.

Thus, out of shapes you can build very complex parts or, the other way round, extract all sub-shapes a more complex shape is made of.

The Part::TopoShape class is the geometrical object that is seen on screen. Essentially all workbenches use these TopoShapes internally to build and display edges, faces, and solids.

Scripting

See also: Part scripting

The main data structure used in the Part module is the BRep data type from OpenCascade. Almost all contents and object types of the Part module are available by Python scripting. This includes geometric primitives, such as Line and Circle (or Arc), and the whole range of TopoShapes, like Vertexes, Edges, Wires, Faces, Solids and Compounds. For each of those objects, several creation methods exist, and for some of them, especially the TopoShapes, advanced operations like boolean union/difference/intersection are also available. Explore the contents of the Part module, as described in the FreeCAD Scripting Basics page, to know more.

The most basic object that can be created is a Part Feature, which has a simple DataPlacement property, and basic properties to define its color and appearance.

Another simple object used in 2D geometrical objects is Part Part2DObject, which is the base of Sketcher SketchObject (Sketcher), and most Draft elements.

Test script

Test the creation of Part Primitives with a script. introduced in version 0.19

import parttests.part_test_objects as pto
pto.create_test_file("example_file")

This script is located in the installation directory of the program, and can be examined to see how the basic primitives are built.

$INSTALL_DIR/Mod/Part/parttests/part_test_objects.py

Examples

To create a line element switch to the Python console and type in:

import Part,PartGui 
doc=App.newDocument()  
l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute()

Let's go through the above python example step by step:

import Part,PartGui
doc=App.newDocument()

loads the Part module and creates a new document

l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)

Line is actually a line segment, hence the start and endpoint.

doc.addObject("Part::Feature","Line").Shape=l.toShape()

This adds a Part object type to the document and assigns the shape representation of the line segment to the 'Shape' property of the added object. It is important to understand here that we used a geometric primitive (the Part.LineSegment) to create a TopoShape out of it (the toShape() method). Only Shapes can be added to the document. In FreeCAD, geometry primitives are used as "building structures" for Shapes.

doc.recompute()

Updates the document. This also prepares the visual representation of the new part object.

Note that a Line Segment can be created by specifying its start and endpoint directly in the constructor, for example Part.LineSegment(point1,point2), or we can create a default line and set its properties afterwards, as we did here.

A circle can be created in a similar way:

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()

Note again, we used the circle (geometry primitive) to construct a shape out of it. We can of course still access our construction geometry afterwards, by doing:

s = f.Shape
e = s.Edges[0]
c = e.Curve

Here we take the shape of our object f, then we take its list of edges. In this case there will be only one because we made the whole shape out of a single circle, so we take only the first item of the Edges list, and we takes its curve. Every Edge has a Curve, which is the geometry primitive it is based on.

Head to the Topological data scripting page if you would like to know more.

Tutorials